# This class uses command objects to implement a button.

import pygame
from pygame.locals import *

class CommandButton:
    """Button class based on the
    Command pattern."""
    
    def __init__(self, rect, command):
        self.rect = rect
        self.command = command
        
    def handleMouseDown(self, x, y):
        if self.rect.collidepoint(x, y):
            if self.command <> None:
                self.command.do()
                
    def draw(self, surface):
        pygame.draw.rect(
            surface,
            Color('gray'),
            self.rect,
            )
